

class Csource;
class Cclone;

class Cfunction : public Cobject {
protected:
	void		emit_ta(void);
public:
	Cfunction	*m_nextP;
	Csource		*m_sourceP;
	char		*m_nameP;		// Name of function
	char		*m_signatureP;	// Mangled signature
	int			m_source_lineno;// Line in source function starts at
	int			m_start_code;	// First line of function
	int			m_end_code;		// Beyond end of function code
	Cclone		*m_clonesP;		// Linked list of clones
#ifdef CORRELATE
	int			m_number;
	int			m_type;
#endif

	Cfunction(const char *nameP, Csource *sourceP);
	void update_names(int locations, locationT *locationsP, codeT *codesP);
	Cclone *locate_clone(const codeT *startP, const codeT *endP);
};

